#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_hero.h"
#include "FileEncrypt.h"
std::auto_ptr<M_hero> M_hero::msSingleton(nullptr);

int M_hero::GetCount()
{
	return (int)mMapData.size();
}

const M_heroData* M_hero::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_heroData>& M_hero::GetMapData()
{
	return mMapData;
}

void M_hero::Reload()
{
	mMapData.clear();
	Load();
}

void M_hero::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_heroData data;
		data.mID = element->IntAttribute("ID");
		data.mname = element->Attribute("name");
		data.mgrade_type = element->IntAttribute("grade_type");
		data.mdefault_have = element->IntAttribute("default_have");
		data.mskill_id = element->IntAttribute("skill_id");
		data.mattribute = element->IntAttribute("attribute");
		data.matk = element->IntAttribute("atk");
		data.micon = element->Attribute("icon");
		data.maspect = element->Attribute("aspect");
		data.mspeed = element->FloatAttribute("speed");
		data.mzoom_factor = element->FloatAttribute("zoom_factor");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_hero::Load()
{
	Load("../Config/M_hero.xml");
}

M_hero* M_hero::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_hero());
	}
	return msSingleton.get();
}
